<template>
  <div>
    <q-list>
      <div v-if="config.filters.length">
        <draggable
          :list="config.filters"
          handle=".filter__drag-handle"
        >
          <q-item
            v-for="(filter, index) in config.filters"
            :key="index"
          >
            <filter_
              :filter="filter"
              @remove="removeFilter(index)"
              @edit="editFilter(index)"
              :available-fields="availableFields"
            />
          </q-item>
        </draggable>
      </div>
      <div
        class="text-grey text-italic q-pa-sm"
        v-else
      >
        No added filters. Click button below to add one
      </div>
    </q-list>
    <q-btn
      icon="add"
      label="Add filter"
      color="green"
      class="q-mt-md"
      @click="addFilter"
    />
    <field-editor
      :field="config.filters[editingFilterIndex]"
      @close="editingFilterIndex = null"
    />
  </div>
</template>

<script>
  import { defaultCollectionFilter } from '../../../../../../utilities/migrateConfig';
  import Filter from './filter';
  import FieldEditor from '../editor/fieldEditor';

  export default {
    name: 'collectionFilters',
    components: { FieldEditor, filter_: Filter },
    props: {
      config: {
        type: Object,
      },
      availableFields: {
        type: Array,
      },
    },
    data() {
      return {
        editingFilterIndex: null,
      };
    },
    methods: {
      removeFilter(index) {
        this.config.filters.splice(index, 1);
      },
      editFilter(index) {
        this.editingFilterIndex = index;
      },
      addFilter() {
        this.config.filters.push({ ...defaultCollectionFilter });
      },
    },
  };
</script>
